
#include <stdio.h>
#include <stdlib.h>

#define MAXM  32

int map[MAXM][MAXM], h, w;
char chs[32];
int chc;

int pred[32][32];
int minx[32], maxx[32], miny[32], maxy[32];

int res[32], resc;

int srt[32];

int char2num (char ch)
{
    int i;
    for ( i = 0;  i < chc;  ++i )
	if ( chs[i] == ch )  return i;
    chs[chc] = ch;
    minx[chc] = miny[chc] = w + h;
    maxx[chc] = maxy[chc] = 0;
    srt[chc] = chc;
    return chc++;
}

void readit (void)
{
    int i, j, c;
    char buf[MAXM];
    chc = 0;
    char2num ('.');
    for ( i = 0;  i < h;  ++i )
    {
	scanf ("%s", buf);
        for ( j = 0;  j < w;  ++j )
	{
    	    c = map[i][j] = char2num (buf[j]);
	    if ( i < minx[c] )  minx[c] = i;
	    if ( i > maxx[c] )  maxx[c] = i;
	    if ( j < miny[c] )  miny[c] = j;
	    if ( j > maxy[c] )  maxy[c] = j;
	}
    }
}

void checkfld (int c, int i, int j)
{
    if ( map[i][j] != c )  ++pred[c][map[i][j]];
}

void fillpred (void)
{
    int i, j;
    for ( i = 0;  i < chc;  ++i )
        for ( j = 0;  j < chc;  ++j )
    	    pred[i][j] = 0;
    for ( i = 0;  i < chc;  ++i )
    {
	for ( j = minx[i];  j <= maxx[i];  ++j )
	{
	    checkfld (i, j, miny[i]);
	    checkfld (i, j, maxy[i]);
	}
	for ( j = miny[i];  j <= maxy[i];  ++j )
	{
	    checkfld (i, minx[i], j);
	    checkfld (i, maxx[i], j);
	}
    }
}

int inres (int n)
{
    int i;
    for ( i = 0;  i < resc;  ++i )
	if ( res[i] == n )  return 1;
    return 0;
}

void genres (void)
{
    int i, j, cnt;
    if ( resc == chc-1 )
    {
	for ( i = 0;  i < resc;  ++i )
	    putchar (chs[res[i]]);
	putchar ('\n');
	return;
    }
    for ( i = 0;  i < chc;  ++i )
	if ( srt[i] != 0 && !inres (srt[i]) )
	{
    	    cnt = 0;
	    for ( j = 1;  j < chc;  ++j )
		if ( j != srt[i] && !inres (j) )
		    if ( pred[j][srt[i]] )  ++cnt;
	    if ( !cnt )
	    {
		res[resc++] = srt[i];
		genres();
		--resc;
	    }
	}
}

int cmpfn (const void* p1, const void* p2)
{
    int i1 = *((const int*)p1);
    int i2 = *((const int*)p2);
    return chs[i1] - chs[i2];
}

int main (void)
{
    for ( ; ; )
    {
        scanf ("%d%d", &h, &w);
	if ( !h || !w )  break;
	readit();
	fillpred();
	resc = 0;
	qsort (srt, chc, sizeof (srt[0]), cmpfn);
	genres();
    }
    return 0;
}
